Index: /trunk/desktop/mainWindow.rbfrm
===================================================================
--- /trunk/desktop/mainWindow.rbfrm	(revision 23)
+++ /trunk/desktop/mainWindow.rbfrm	(revision 24)
@@ -2598,5 +2418,5 @@
       Height          =   32
       Index           =   -2147483648
-      Left            =   716
+      Left            =   786
       LockedInPosition=   False
       mode            =   "read"
@@ -2605,5 +2425,5 @@
       Stop            =   0
       TabPanelIndex   =   0
-      Top             =   -6
+      Top             =   -16
       Width           =   32
       XON             =   ""
@@ -2621,6 +2441,6 @@
       InitialParent   =   ""
       Italic          =   ""
-      Left            =   326
-      LockBottom      =   ""
+      Left            =   612
+      LockBottom      =   True
       LockedInPosition=   False
       LockLeft        =   ""
@@ -2633,15 +2453,14 @@
       TextFont        =   "System"
       TextSize        =   0
-      Top             =   330
+      Top             =   388
       Underline       =   ""
       Visible         =   True
       Width           =   88
    End
-   Begin PushButton PushButton_SaveProfile
+   Begin StaticText StaticText_SerialPort
       AutoDeactivate  =   True
       Bold            =   ""
-      Cancel          =   ""
-      Caption         =   "Save Profile"
-      Default         =   ""
+      DataField       =   ""
+      DataSource      =   ""
       Enabled         =   True
       Height          =   20
@@ -2650,5 +2469,38 @@
       InitialParent   =   ""
       Italic          =   ""
-      Left            =   520
+      Left            =   20
+      LockBottom      =   ""
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Multiline       =   ""
+      Scope           =   0
+      TabIndex        =   46
+      TabPanelIndex   =   0
+      Text            =   "COM Port"
+      TextAlign       =   0
+      TextColor       =   "&cB8B8B8"
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   58
+      Underline       =   ""
+      Visible         =   True
+      Width           =   100
+   End
+   Begin PopupMenu PopupMenu_SerialPort
+      AutoDeactivate  =   True
+      Bold            =   ""
+      DataField       =   ""
+      DataSource      =   ""
+      Enabled         =   True
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      InitialValue    =   ""
+      Italic          =   ""
+      Left            =   20
+      ListIndex       =   0
       LockBottom      =   ""
       LockedInPosition=   False
@@ -2657,13 +2509,13 @@
       LockTop         =   ""
       Scope           =   0
-      TabIndex        =   45
+      TabIndex        =   47
       TabPanelIndex   =   0
       TabStop         =   True
       TextFont        =   "System"
       TextSize        =   0
-      Top             =   330
+      Top             =   90
       Underline       =   ""
-      Visible         =   False
-      Width           =   100
+      Visible         =   True
+      Width           =   128
    End
    Begin StaticText StaticText_Version
@@ -2678,5 +2530,36 @@
       InitialParent   =   ""
       Italic          =   ""
-      Left            =   522
+      Left            =   20
+      LockBottom      =   True
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Multiline       =   ""
+      Scope           =   0
+      TabIndex        =   48
+      TabPanelIndex   =   0
+      Text            =   "Version "
+      TextAlign       =   0
+      TextColor       =   "&cB8B8B8"
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   388
+      Underline       =   ""
+      Visible         =   True
+      Width           =   100
+   End
+   Begin StaticText StaticText_Profiles
+      AutoDeactivate  =   True
+      Bold            =   ""
+      DataField       =   ""
+      DataSource      =   ""
+      Enabled         =   True
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      Italic          =   ""
+      Left            =   20
       LockBottom      =   ""
       LockedInPosition=   False
@@ -2686,15 +2569,132 @@
       Multiline       =   ""
       Scope           =   0
-      TabIndex        =   46
+      TabIndex        =   51
       TabPanelIndex   =   0
-      Text            =   "Version "
+      Text            =   "Profiles"
       TextAlign       =   0
-      TextColor       =   &h000000
+      TextColor       =   "&cB8B8B8"
       TextFont        =   "System"
       TextSize        =   0
-      Top             =   14
+      Top             =   122
       Underline       =   ""
       Visible         =   True
       Width           =   100
+   End
+   Begin PopupMenu PopupMenu_Profile
+      AutoDeactivate  =   True
+      Bold            =   ""
+      DataField       =   ""
+      DataSource      =   ""
+      Enabled         =   True
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      InitialValue    =   ""
+      Italic          =   ""
+      Left            =   20
+      ListIndex       =   0
+      LockBottom      =   ""
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Scope           =   0
+      TabIndex        =   54
+      TabPanelIndex   =   0
+      TabStop         =   True
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   154
+      Underline       =   ""
+      Visible         =   True
+      Width           =   128
+   End
+   Begin PushButton PushButton_SaveProfile
+      AutoDeactivate  =   True
+      Bold            =   ""
+      Cancel          =   ""
+      Caption         =   "Save"
+      Default         =   ""
+      Enabled         =   False
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      Italic          =   ""
+      Left            =   20
+      LockBottom      =   ""
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Scope           =   0
+      TabIndex        =   55
+      TabPanelIndex   =   0
+      TabStop         =   True
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   250
+      Underline       =   ""
+      Visible         =   True
+      Width           =   88
+   End
+   Begin PushButton PushButton_Delete
+      AutoDeactivate  =   True
+      Bold            =   ""
+      Cancel          =   ""
+      Caption         =   "Delete"
+      Default         =   ""
+      Enabled         =   False
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      Italic          =   ""
+      Left            =   20
+      LockBottom      =   ""
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Scope           =   0
+      TabIndex        =   56
+      TabPanelIndex   =   0
+      TabStop         =   True
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   218
+      Underline       =   ""
+      Visible         =   True
+      Width           =   88
+   End
+   Begin PushButton PushButton_Create
+      AutoDeactivate  =   True
+      Bold            =   ""
+      Cancel          =   ""
+      Caption         =   "Create"
+      Default         =   ""
+      Enabled         =   True
+      Height          =   20
+      HelpTag         =   ""
+      Index           =   -2147483648
+      InitialParent   =   ""
+      Italic          =   ""
+      Left            =   20
+      LockBottom      =   ""
+      LockedInPosition=   False
+      LockLeft        =   ""
+      LockRight       =   ""
+      LockTop         =   ""
+      Scope           =   0
+      TabIndex        =   57
+      TabPanelIndex   =   0
+      TabStop         =   True
+      TextFont        =   "System"
+      TextSize        =   0
+      Top             =   186
+      Underline       =   ""
+      Visible         =   True
+      Width           =   88
    End
 End
@@ -2732,4 +2732,9 @@
 		          //Could not open
 		          MsgBox "Error opening defined com port"
+		        else
+		          //Enable buttons
+		          PushButton_Read.Enabled = True
+		          PushButton_Write.Enabled = True
+		          PushButton_Reset.Enabled = True
 		        end if
 		        //No need to continue loop
@@ -2768,11 +2773,11 @@
 		    StaticText_Gain.TextColor = &c000000
 		    StaticText_Nuetral.TextColor = &c000000
-		    StaticText_Profiles.TextColor = &c000000
+		    //StaticText_Profiles.TextColor = &c000000
 		    StaticText_Punch.TextColor = &c000000
-		    StaticText_SerialPort.TextColor = &c000000
+		    //StaticText_SerialPort.TextColor = &c000000
 		    StaticText_Speed.TextColor = &c000000
 		    StaticText_STGain.TextColor = &c000000
 		    StaticText_THGain.TextColor = &c000000
-		    StaticText_Version.TextColor = &c000000
+		    //StaticText_Version.TextColor = &c000000
 		    StaticText_VerticalIntertia.TextColor = &c000000
 		    
@@ -3145,4 +3150,560 @@
 	#tag EndEvent
 #tag EndEvents
+#tag Events EditField_Byte9
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte09 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte8
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte08 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte7
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte07 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte6
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte06 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte5
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte05 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte4
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte04 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte3
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte03 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events Slider_THGain
+	#tag Event
+		Sub ValueChanged()
+		  ICSSerialPort1.Byte17 = chrb(me.Value)
+		  //Check to see if we need to update the edit field
+		  //This prevents the edit field from triggering this event that then updates the edit field again
+		  //Causing the cursor to move to the begginning of the editfield
+		  if EditField_THGain.Text <> str(me.Value) then
+		    EditField_THGain.Text = str(me.Value)
+		  end if
+		  
+		  
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_THGain
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 1 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte17 = chrb(i)
+		  
+		  Slider_THGain.Value = val(me.Text)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events Slider_STGain
+	#tag Event
+		Sub ValueChanged()
+		  ICSSerialPort1.Byte16 = chrb(me.Value)
+		  //Check to see if we need to update the edit field
+		  //This prevents the edit field from triggering this event that then updates the edit field again 
+		  //Causing the cursor to move to the begginning of the editfield
+		  if EditField_STGain.Text <> str(me.Value) then
+		    EditField_STGain.Text = str(me.Value)
+		  end if
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_STGain
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 1 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte16 = chrb(i)
+		  
+		  Slider_STGain.Value = val(me.Text)
+		  
+		  
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_BackTiming
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte15 = chrb(&h01)
+		  Case 1
+		    ICSSerialPort1.Byte15 = chrb(&h05)
+		  Case 2
+		    ICSSerialPort1.Byte15 = chrb(&h0A)
+		  Case 3
+		    ICSSerialPort1.Byte15 = chrb(&h14)
+		  Case 4
+		    ICSSerialPort1.Byte15 = chrb(&h28)
+		  Case 5
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_VerticalInteria
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte13 = chrb(&h01)
+		  Case 1
+		    ICSSerialPort1.Byte13 = chrb(&h02)
+		  Case 2
+		    ICSSerialPort1.Byte13 = chrb(&h03)
+		  Case 3
+		    ICSSerialPort1.Byte13 = chrb(&h04)
+		  Case 4
+		    ICSSerialPort1.Byte13 = chrb(&hFF)
+		  Case 5
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_Nuetral
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte11 = chrb(&h82)
+		    ICSSerialPort1.Byte12 = chrb(&h7C)
+		    
+		  Case 1
+		    ICSSerialPort1.Byte11 = chrb(&h88)
+		    ICSSerialPort1.Byte12 = chrb(&h78)
+		    
+		  Case 2
+		    ICSSerialPort1.Byte11 = chrb(&h94)
+		    ICSSerialPort1.Byte12 = chrb(&h6C)
+		    
+		  Case 3
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_DFreq
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte08 = chrb(&h40)
+		  Case 1
+		    ICSSerialPort1.Byte08 = chrb(&h78)
+		  Case 2
+		    ICSSerialPort1.Byte08 = chrb(&hFF)
+		  Case 3
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_Dump
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte07 = chrb(&h01)
+		  Case 1
+		    ICSSerialPort1.Byte07 = chrb(&h02)
+		  Case 2
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_DBand
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte06 = chrb(&h01)
+		  Case 1
+		    ICSSerialPort1.Byte06 = chrb(&h02)
+		  Case 2
+		    ICSSerialPort1.Byte06 = chrb(&h03)
+		  Case 3
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events Slider_Punch
+	#tag Event
+		Sub ValueChanged()
+		  ICSSerialPort1.Byte05 = chrb(me.Value)
+		  //Check to see if we need to update the edit field
+		  //This prevents the edit field from triggering this event that then updates the edit field again
+		  //Causing the cursor to move to the begginning of the editfield
+		  if EditField_Punch.Text <> str(me.Value) then
+		    EditField_Punch.Text = str(me.Value)
+		  end if
+		  
+		  
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Punch
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 1 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte05 = chrb(i)
+		  
+		  Slider_Punch.Value = val(me.Text)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_Speed
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  Case 0
+		    ICSSerialPort1.Byte04 = chrb(&h0A)
+		  Case 1
+		    ICSSerialPort1.Byte04 = chrb(&h14)
+		  Case 2
+		    ICSSerialPort1.Byte04 = chrb(&h1E)
+		  Case 3
+		    ICSSerialPort1.Byte04 = chrb(&h28)
+		  Case 4
+		    ICSSerialPort1.Byte04 = chrb(&hFF)
+		  Case 5
+		    
+		  End Select
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_Gain
+	#tag Event
+		Sub Change()
+		  Select Case me.ListIndex
+		    
+		  case 0
+		    ICSSerialPort1.Byte03 = chrb(&h32)
+		    
+		  case 1
+		    ICSSerialPort1.Byte03 = chrb(&h64)
+		    
+		  case 2
+		    ICSSerialPort1.Byte03 = chrb(&hFF)
+		    
+		  case 3
+		    
+		  End Select
+		  
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PopupMenu_CarType
+	#tag Event
+		Sub Change()
+		  ICSSerialPort1.setCarType(me.Text)
+		  disableControls
+		  
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte12
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte12 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte11
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte11 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte10
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte10 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte17
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte17 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte16
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte16 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte15
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte15 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte14
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte14 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events EditField_Byte13
+	#tag Event
+		Sub TextChange()
+		  //Make sure we have a valid value if not then set it to something
+		  if me.Text <> "" then
+		    if val(me.Text) > 255 or val(me.Text) < 0 then
+		      me.Text = "255"
+		    end if
+		  end if
+		  
+		  dim d as double
+		  dim i as integer
+		  d = val(me.Text)
+		  i = d
+		  ICSSerialPort1.Byte13 = chrb(i)
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events ICSSerialPort1
+	#tag Event
+		Sub valuesChanged()
+		  //Update the screens with the new values
+		  updateAdvancedScreen
+		  updateCarScreen
+		End Sub
+	#tag EndEvent
+#tag EndEvents
+#tag Events PushButton_Default
+	#tag Event
+		Sub Action()
+		  ICSSerialPort1.setDefaultValues
+		End Sub
+	#tag EndEvent
+#tag EndEvents
 #tag Events PopupMenu_SerialPort
 	#tag Event
@@ -3166,4 +3727,14 @@
 		          //Could not open
 		          MsgBox "Error opening defined com port"
+		          //Disable buttons
+		          PushButton_Read.Enabled = False
+		          PushButton_Write.Enabled = False
+		          PushButton_Reset.Enabled = False
+		        else
+		          //Enable buttons
+		          PushButton_Read.Enabled = True
+		          PushButton_Write.Enabled = True
+		          PushButton_Reset.Enabled = True
+		          
 		        end if
 		        //Save and exit
